freeslot("sfx_twl1", "sfx_twl2", "spr_falla5", "spr_spina1")

sfxinfo[sfx_twl1].caption = "Twirl"
sfxinfo[sfx_twl2].caption = "Twirl Thok"


local function doTwirlThok(player)
	player.mo.state = S_PLAY_TWIRLTHOKGHOST
	player.mo.momz = 0
	player.thoking = true
	S_StartSound(player.mo, sfx_thok)
	S_StartSound(player.mo, sfx_twl2)
end

local function doTwirl(player)
	player.mo.state = S_PLAY_TWIRL1
	player.mo.momz = 0
	player.twirling = true
	if player.powers[pw_super] then
		S_StartSound(player.mo, sfx_s3kc2s)
		P_SpawnGhostMobj(player.mo)
			else
		S_StartSound(player.mo, sfx_twl1)
	end
end

addHook("PlayerThink", function(player) ----------Make tapping Spin necessary to Twirl----------
        if player.mo.skin ~= "pierre" then
            return false
        end
        
        if not (player.cmd.buttons & BT_USE) then
            player.spintapready = true
            player.spintapping = false
        elseif player.spintapready then
            player.spintapping = true
            player.spintapready = false
        else
            player.spintapping = false
        end
end)

addHook("ThinkFrame", function() ---------Twirling and Twirl Thoking disables Rolling state----------
	for player in players.iterate do
		if player.mo.skin ~= 'pierre' then
			continue
		end
		
		if player.twirling == true then
			player.thoking = false
		end
		
		if player.twirling == true
			player.pflags = $ & ~PF_SPINNING
		end
		
		if player.thoking == true
			player.pflags = $ & ~PF_SPINNING
		end
		
		if player.mo.skin ~= 'pierre' then
            return
        end
		player.twirltime = $ or 0
	end
end)

addHook("ThinkFrame", function() -----------Ring Loss and Twirl Cooldown----------
 for player in players.iterate
        if player.mo.skin ~= 'pierre' then
            continue
        end
        
        local threshold = 20*TICRATE
        if player.losstime < 400 then --Losstime never drops below 400
            player.losstime = 400
        end
        
        if player.twirltime == 0 then --Twirl reset clock        
            player.twirlready = true    
        end
        
       if player.twirling == true --Super Form reduces Twirltime
            if player.powers[pw_super] then
                player.twirltime = 5
            else
                player.twirltime = 15
            end
            player.twirling = false
        end
        
        if player.twirltime ~= 0 --Subtractive cooldown after Twirl
            player.twirlready = false
            player.twirltime = $ - 1
        end
    end
end)        

addHook("ThinkFrame", function() ---------Touching the Ground resets Thok-----------
	for player in players.iterate do
		if player.mo.skin ~= 'pierre' then
			continue
		end
			
		if P_IsObjectOnGround(player.mo) then
			player.thokready = true
		end
		
		if P_IsObjectOnGround(player.mo) then
			player.thoking = false
		end

		if player.thoking then
			player.thokready = false
			player.thoking = false
		end
			
		if player.mo.state == S_PLAY_RIDE then --Riding object resets Thok
			player.thokready = true
		end
			
		if player.mo.state == S_PLAY_RIDE then
			player.thoking = false
		end
	end
end)

addHook("AbilitySpecial", function(player) ---------Execute Twirl Thok----------
	if player.mo.skin ~= 'pierre' then
		return false
	end
	
	if player.thokready == true then
		doTwirlThok(player)
		return true
	end
end)

addHook("JumpSpinSpecial", function(player) ----------Execute Twirl----------
    if player.mo.skin ~= "pierre" then
        return false
    end

    if player.twirlready == true
        if player.powers[pw_super] then
            doTwirl(player)
        else
            if player.spintapping then
                doTwirl(player)
            end
        end
    end
end)